diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
index 44edd94dc..deefb625a 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
@@ -78,7 +78,7 @@ public class ItemPaintBrush extends Item {
             if (!entities.isEmpty()) {
                 MobSheep sheep = entities.get(0);
                 DyeColor woolColor = getColor(itemStack);
-                if(sheep.getFleeceColor() != woolColor)
+                if(woolColor != null && sheep.getFleeceColor() != woolColor)
                 {
                     sheep.setFleeceColor(woolColor);
                     consumePaint(itemStack, null);
@@ -103,7 +103,7 @@ public class ItemPaintBrush extends Item {
         {
             MobSheep mobSheep = (MobSheep)mob;
             DyeColor woolColor = getColor(itemstack);
-            if(mobSheep.getFleeceColor() != woolColor)
+            if(woolColor != null && mobSheep.getFleeceColor() != woolColor)
             {
                 mobSheep.setFleeceColor(woolColor);
                 consumePaint(itemstack, player);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPainting.java b/game/core/src/main/java/net/minecraft/core/item/ItemPainting.java
index 00fb3dfd2..bf0c11862 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPainting.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPainting.java
@@ -18,7 +18,7 @@ public class ItemPainting extends Item
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         if (!world.isClientSide && !entityplayer.isSneaking())
         {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
index 1e4939b8b..0f64b3981 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -27,7 +27,7 @@ public class ItemPebble extends Item implements IDispensable
 
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         itemstack.consumeItem(entityplayer);
         world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java b/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
index 9044fab12..07b5f30e1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
@@ -5,6 +5,7 @@ import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.player.inventory.slot.Slot;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -83,6 +84,14 @@ public class ItemQuiver extends Item implements IArmorItem<HumanArmorShape>
     	
     	return stackInSlot;
     }
+
+	@Override
+	public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer) {
+		HumanArmorShape humanArmorShape = getArmorShape();
+		ItemStack currentArmorInSlot = entityplayer.getItemInArmorSlot(humanArmorShape);
+		entityplayer.setItemInArmorSlot(humanArmorShape, itemstack);
+		return currentArmorInSlot;
+	}
     
     private int getArrowCount(ItemStack stack) {
     	return stack.getMaxDamage() - stack.getMetadata();
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java b/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
index 2d066f5cd..0c8f61831 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
@@ -1,8 +1,11 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemQuiverEndless extends Item implements IArmorItem<HumanArmorShape>
 {
@@ -13,6 +16,14 @@ public class ItemQuiverEndless extends Item implements IArmorItem<HumanArmorShap
         setMaxStackSize(1);
     }
 
+    @Override
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer) {
+        HumanArmorShape humanArmorShape = getArmorShape();
+        ItemStack currentArmorInSlot = entityplayer.getItemInArmorSlot(humanArmorShape);
+        entityplayer.setItemInArmorSlot(humanArmorShape, itemstack);
+        return currentArmorInSlot;
+    }
+
     @Override
     public ArmorMaterial getArmorMaterial() {
         return null;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java b/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
index b689064ad..600c5a39c 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
@@ -5,6 +5,8 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileSnowball;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -18,7 +20,7 @@ public class ItemSnowball extends Item implements IDispensable
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         itemstack.consumeItem(entityplayer);
         world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSoup.java b/game/core/src/main/java/net/minecraft/core/item/ItemSoup.java
index f15fda846..5025c43d1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSoup.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSoup.java
@@ -2,6 +2,8 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemSoup extends ItemFood
 {
@@ -12,7 +14,7 @@ public class ItemSoup extends ItemFood
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player entityplayer)
     {
         ItemStack stack = super.onUseItem(itemstack, world, entityplayer);
         return stack.stackSize <= 0 ? Items.BOWL.getDefaultStack() : stack;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
index 63237381b..8baed9b49 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -375,9 +375,9 @@ public final class ItemStack {
         return metadata == itemstack.metadata;
     }
 
-    public boolean isItemEqual(@NotNull ItemStack itemstack)
+    public boolean isItemEqual(@Nullable ItemStack itemstack)
     {
-        return itemID == itemstack.itemID && metadata == itemstack.metadata;
+        return itemstack != null && itemID == itemstack.itemID && metadata == itemstack.metadata;
     }
 
     public String getItemKey()
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index fb1e30cdd..18a402a33 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -9,6 +9,8 @@ import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -18,7 +20,7 @@ public class ItemWandSpawner extends Item implements IDispensable
         super(name, namespaceId, id);
     }
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player player)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player player)
     {
         if (player.gamemode != Gamemode.creative){
             player.sendTranslatedChatMessage("wand.wrongmode");
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
index 29b1454ae..484abe474 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
@@ -34,7 +34,7 @@ public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T>
     }
     
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player player)
+    public @Nullable ItemStack onUseItem(@NotNull ItemStack itemstack, @NotNull World world, @NotNull Player player)
     {
         double reachDistance = player.getGamemode().getBlockReachDistance();
         HitResult rayTraceResult = player.rayTrace(reachDistance, 1f, true, false, false);
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
index f1c473276..8d7a35bcc 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
@@ -17,14 +17,15 @@ import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.DamageType;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ContainerInventory
     implements Container
 {
     protected int hotbarOffset = 0;
-    public ItemStack[] mainInventory;
-    public ItemStack[] armorInventory;
+    public @Nullable ItemStack @NotNull [] mainInventory;
+    public @Nullable ItemStack @NotNull [] armorInventory;
     protected int currentItem;
     public Player player;
     private ItemStack heldItem;
@@ -398,7 +399,7 @@ public class ContainerInventory
         }
     }
 
-    public ItemStack armorItemInSlot(IArmorShape shape)
+    public @Nullable ItemStack armorItemInSlot(@NotNull IArmorShape shape)
     {
         return armorInventory[shape.getSlotIndex()];
     }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
index f0562c8fd..3c1333e38 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
@@ -85,11 +85,6 @@ public class SlotArmor extends Slot
         if (wornMaterials.size() >= 4) {
             menu.inventory.player.triggerAchievement(Achievements.ALL_ARMOR_TYPES);
         }
-        
-        if (getItemStack() != null && container instanceof ContainerInventory) {
-            Player player = ((ContainerInventory) container).player;
-            player.world.playSoundAtEntity(player, player, "random.equip", 2f, 1f);
-        }
     }
 
     public void set(final @Nullable ItemStack itemstack)
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index f0228bf0d..7195f0743 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -229,7 +229,7 @@ public class ChunkDecoratorOverworld
             int j7 = x + rand.nextInt(16);
             int k10 = minY + rand.nextInt(rangeY / 2);
             int j13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicMoss.variantMap, 32)).place(world, rand, j7, k10, j13);
+            (new WorldFeatureMoss(BlockLogicMoss.variantMap, 32)).place(world, rand, j7, k10, j13);
         }
 
         for (int j4 = 0; j4 < oreHeightModifier; j4++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMoss.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMoss.java
new file mode 100644
index 000000000..5169d0125
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMoss.java
@@ -0,0 +1,111 @@
+package net.minecraft.core.world.generate.feature;
+
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class WorldFeatureMoss extends WorldFeature
+{
+    private int minableBlockId;
+    private int numberOfBlocks;
+    private final Int2IntArrayMap variantMap;
+    @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks"})
+    public WorldFeatureMoss(int blockId, int numberOfBlocks)
+    {
+        minableBlockId = blockId;
+        this.numberOfBlocks = numberOfBlocks;
+        this.variantMap = null;
+    }
+    @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks", "variantMap"})
+    public WorldFeatureMoss(@NotNull Int2IntArrayMap variantMap, int numberOfBlocks)
+    {
+        this.numberOfBlocks = numberOfBlocks;
+        this.variantMap = variantMap;
+    }
+
+    @Override
+	public boolean place(World world, Random random, int xStart, int yStart, int zStart)
+    {
+        float f = random.nextFloat() * MathHelper.PI;
+        double xMax = (float)(xStart + 8) + MathHelper.sin(f) * (float)numberOfBlocks / 8F;
+        double xMin = (float)(xStart + 8) - MathHelper.sin(f) * (float)numberOfBlocks / 8F;
+        double zMax = (float)(zStart + 8) + MathHelper.cos(f) * (float)numberOfBlocks / 8F;
+        double zMin = (float)(zStart + 8) - MathHelper.cos(f) * (float)numberOfBlocks / 8F;
+        double yMax = yStart + random.nextInt(3) + 2;
+        double yMin = yStart - random.nextInt(3) + 2;
+        for(int l = 0; l <= numberOfBlocks; l++)
+        {
+            double d6 = xMax + (xMin - xMax) * (double)l / (double)numberOfBlocks;
+            double d7 = yMax + (yMin - yMax) * (double)l / (double)numberOfBlocks;
+            double d8 = zMax + (zMin - zMax) * (double)l / (double)numberOfBlocks;
+            double d9 = random.nextDouble() * (double)numberOfBlocks / 16D;
+            double d10 = (double)(MathHelper.sin((float)l * MathHelper.PI / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            double d11 = (double)(MathHelper.sin((float)l * MathHelper.PI / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            int xVeinStart = MathHelper.floor(d6 - d10 / 2D);
+            int yVeinStart = MathHelper.floor(d7 - d11 / 2D);
+            int zVeinStart = MathHelper.floor(d8 - d10 / 2D);
+            int xVeinEnd = MathHelper.floor(d6 + d10 / 2D);
+            int yVeinEnd = MathHelper.floor(d7 + d11 / 2D);
+            int zVeinEnd = MathHelper.floor(d8 + d10 / 2D);
+            for(int x = xVeinStart; x <= xVeinEnd; x++)
+            {
+                double d12 = (((double)x + 0.5D) - d6) / (d10 / 2D);
+                if(d12 * d12 >= 1.0D)
+                {
+                    continue;
+                }
+                for(int y = yVeinStart; y <= yVeinEnd; y++)
+                {
+                    double d13 = (((double)y + 0.5D) - d7) / (d11 / 2D);
+                    if(d12 * d12 + d13 * d13 >= 1.0D)
+                    {
+                        continue;
+                    }
+                    for(int z = zVeinStart; z <= zVeinEnd; z++)
+                    {
+                        double d14 = (((double)z + 0.5D) - d8) / (d10 / 2D);
+                        if(d12 * d12 + d13 * d13 + d14 * d14 < 1.0D && airExposed(world, x, y, z))
+                        {
+                        	if (variantMap != null)
+                        	{
+                                int blockId = world.getBlockId(x, y, z);
+                                if (blockId <= 0) continue;
+                                if (variantMap.containsKey(blockId)){
+                                    world.setBlock(x, y, z, variantMap.get(blockId));
+                                }
+                        	}
+                        	else
+                        	{
+                        		int id = world.getBlockId(x, y, z);
+                        		if (id == Blocks.STONE.id() || id == Blocks.COBBLE_NETHERRACK.id() ||
+                        				id == Blocks.BASALT.id() || id == Blocks.LIMESTONE.id() ||
+                        				id == Blocks.GRANITE.id())
+                        		{
+                        			world.setBlock(x, y, z, minableBlockId);
+                        		}
+                        	}
+                        }
+                    }
+
+                }
+
+            }
+
+        }
+
+        return true;
+    }
+
+    public boolean airExposed(@NotNull World world, int x, int y, int z) {
+        for (int i = 0; i < Side.sides.length; i++) {
+            Side s = Side.sides[i];
+            if (world.isAirBlock(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ())) return true;
+        }
+        return false;
+    }
+}
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index fcc26648c..4cac9c938 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -186,6 +186,13 @@ options.dynamicCursor=Dynamic Cursor
 options.enableDevResourceLoading=Developer Resource Loading
 options.enableMultiDrawRendering=Enable Multi-Draw Renderer (experimental!)
 options.doJCECheck=Do JCE Check
+options.musicToasts=Music Toasts
+options.musicFrequency=Music Frequency
+options.musicFrequency.continuous=Continuous
+options.musicFrequency.frequent=Frequent
+options.musicFrequency.default=Default
+options.musicFrequency.unusual=Unusual
+options.musicFrequency.rare=Rare
 
 options.fov.modification=Contextual FOV Modification
 options.screen.motion.effects=Screen Motion Effects
